package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.ExceptionConst;

public class PUTSTATIC extends FieldInstruction implements ExceptionThrower, PopInstruction
{
    PUTSTATIC() {
    }
    
    public PUTSTATIC(int index) {
        super((short)179, index);
    }
    
    @Override
    public int consumeStack(ConstantPoolGen cpg) {
        return this.getFieldSize(cpg);
    }
    
    @Override
    public Class<?>[] getExceptions() {
        return ExceptionConst.createExceptions(ExceptionConst.EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, new Class[] { ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR });
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitExceptionThrower(this);
        v.visitStackConsumer(this);
        v.visitPopInstruction(this);
        v.visitTypedInstruction(this);
        v.visitLoadClass(this);
        v.visitCPInstruction(this);
        v.visitFieldOrMethod(this);
        v.visitFieldInstruction(this);
        v.visitPUTSTATIC(this);
    }
}
